// =====================================
// =========== Grid System  ============
// =====================================

// Equal height things (See the 2.x branch to find the old solution (jquery + css calc)
.cell{
  > .card:only-child,
  > .box-style:only-child,
  > .paragraph--type-entityreference:only-child > .card,
  > .box-style:only-child,
  > .paragraph:not([class*="mb-"]):only-child{
    height:100%;
    margin-bottom:0;
  }
}

// Fix grid containers with less content - make full width
.grid-container{
  width:100%;
}

// Fix nested grid containers
.grid-container{
  .grid-container {
    padding-left: 0;
    padding-right: 0;
  }
}

// Add modifier to prevent breaking flexbox .rows
.grid-x-nowrap{
  flex-flow: nowrap;
}

// Re-add grid on position:relative / absolute elements
.dropdown-pane{
  > .grid-container{
    @include xy-grid-container;
  }
}

// Force viewport wide containers
.viewport-width {
  @include viewport-width();
  > .grid-container{
    // Re-add grid spaces on forced viewport width elements
    @include xy-grid-container();
  }
  // Fix nested viewport-width containers
  .viewport-width{
    @include undo-viewport-width();
  }
}
.grid-x {
  .grid-container {
    padding-left: 0;
    padding-right: 0;
  }
}

// Allow images to overscale in viewport width containers
.drowl-layout-container{
  &.viewport-width {
    *:not(.cell) > .paragraph--type-image{
      img{
        max-width:none;
        width:100%;
      }
    }
  }
}

// =====================================
// ===== Embed entities alignment ======
// =====================================

$floated-elements-grid-gutter: $thin-grid;

// .align-left & -right are ZF grid formatter classes, so we have to limit them

// Good ol' floats (basicly for images floating text)
.embedded-entity.align-left,
img.align-left,
.embed-left {
  text-align: center;
  width:50%;
  max-width: 470px;
  float: left;
  margin: 0 $floated-elements-grid-gutter $floated-elements-grid-gutter 0;
}

.embedded-entity.align-right,
img.align-right,
.embed-right {
  text-align: center;
  width:50%;
  max-width: 470px;
  float: right;
  margin: 0 0 $floated-elements-grid-gutter $floated-elements-grid-gutter;
}

// Fix CSS Shapes for image paragraphs
.embed-right[class*="css-shape-"],
.embed-left[class*="css-shape-"]{
  shape-margin: $floated-elements-grid-gutter;
  // The shapes working with percentage values, so we have to ensure the image has the right ratio
  margin:0;
}

// Formatters
// Reverse order of none fixed defined layouts (eg. Image + Text)
.reverse-layout-order > .grid-x,
.grid-x.reverse-layout-order,
.flex-dir-row-reverse{
  flex-direction: row-reverse;
}

// Min height
.min-height {
  &-10 {
    min-height: 10vh;
  }
  &-20 {
    min-height: 20vh;
  }
  &-30 {
    min-height: 30vh;
  }
  &-40 {
    min-height: 40vh;
  }
  &-50 {
    min-height: 50vh;
  }
  &-60 {
    min-height: 60vh;
  }
  &-70 {
    min-height: 70vh;
  }
  &-80 {
    min-height: 80vh;
  }
  &-90 {
    min-height: 90vh;
  }
  &-100 {
    min-height: 100vh;
  }
}

// Visibility classes
// -- Hide elements (Important: Better use Drupal cores .element-invisible if the element needs to be readable by screen readers)
.hidden {
  display: none !important;
}
